package idxserialize

import (
	// "fmt"
	"os"
	"runtime"
	"testing"

	idxconfig "gitlab.dms3.io/is/go-idx-config"
)

func TestConfig(t *testing.T) {
	const filename = ".dms3config"
	cfgWritten := new(idxconfig.IdxConfig)

	err := WriteConfigFile(filename, cfgWritten)
	if err != nil {
		t.Fatal(err)
	}
	cfgRead, err := Load(filename)
	if err != nil {
		t.Fatal(err)
	}
	// fmt.Printf("Metadata: %v\n", cfgRead.Metadata)
	if len(cfgWritten.Metadata.Kind) != len(cfgRead.Metadata.Kind) {
		t.Fatalf("field name read: %v, does not match written: %v", cfgRead.Metadata, cfgWritten.Metadata)
	}
	st, err := os.Stat(filename)
	if err != nil {
		t.Fatalf("cannot stat idxconfig file: %v", err)
	}

	if runtime.GOOS != "windows" { // see https://golang.org/src/os/types_windows.go
		if g := st.Mode().Perm(); g&0117 != 0 {
			t.Fatalf("idxconfig file should not be executable or accessible to world: %v", g)
		}
	}
}
